/**
* This code was generated by v0 by Vercel.
* @see https://v0.dev/t/gur0C4inpuL
* Documentation: https://v0.dev/docs#integrating-generated-code-into-your-nextjs-app
*/

/** Add fonts into your Next.js project:

import { Inter } from 'next/font/google'

inter({
  subsets: ['latin'],
  display: 'swap',
})

To read more about using these font, please visit the Next.js documentation:
- App Directory: https://nextjs.org/docs/app/building-your-application/optimizing/fonts
- Pages Directory: https://nextjs.org/docs/pages/building-your-application/optimizing/fonts
**/
import { Dialog, DialogContent, DialogHeader, DialogTitle, DialogDescription } from "@/components/ui/dialog"
import { Button } from "@/components/ui/button"
import { Input } from "@/components/ui/input"
import { Label } from "@/components/ui/label"
import { useEffect, useRef, useState } from "react"
import { Loader2 } from "lucide-react"
import { generate_password_file_name } from "./KeyGeneratorDialog"
import { User } from "@/lib/api"

export function KeyImportDialog({
	open,
	justLoggedIn,
	user,
	onCancel,
	onSubmit,
	onError,
}: {
	open: boolean,
	justLoggedIn: boolean,
	user: User | null,
	onCancel: () => void,
	onSubmit: (password: string) => Promise<void>,
	onError: (error: unknown) => void,
}) {
	const [password, setPassword] = useState("");
	const [submitting, setSubmitting] = useState(false);
	const fileInputRef = useRef(null as HTMLInputElement | null);


	useEffect(() => {
		if (!open) {
			// delete password when the dialog closes
			setPassword("");
		}
	}, [open]);

	const handleSubmit = (password: string) => {
		setSubmitting(true);
		onSubmit(password).then(
			() => {
				setPassword("");
			}
		).catch(onError).finally(() => {
			setSubmitting(false);
		});
	}

	return (
		<Dialog open={open} modal={true} onOpenChange={(open) => {
			if (!open) {
				onCancel();
			}
		}}>
			<DialogContent className="sm:max-w-[500px]"
			>
				<DialogHeader>
					<DialogTitle>Ende-zu-Ende Schlüssel Entsperren</DialogTitle>
					<DialogDescription>
						Gebe hier das Passwort für einen deiner Ende-zu-Ende Schlüssel an, damit du deine Nachrichten einsehen oder Formulare einreichen kannst.
						Falls du das Passwort als Datei heruntergeladen hast, hat diese wahrscheinlich den Namen <code>{generate_password_file_name(user)}</code>.
					</DialogDescription>
				</DialogHeader>
				<form className="grid gap-4 py-4" onSubmit={(event) => { event.preventDefault(); handleSubmit(password) }}>
					<div className="grid grid-cols-[1fr_auto_auto] items-center gap-4">
						<div className="grid gap-2">
							<Label htmlFor="password">Passwort angeben</Label>
							<Input id="password" type="text" className="font-mono"
								disabled={submitting}
								value={password}
								onChange={(event) => {
									//event.preventDefault();
									setPassword(event.target.value);
								}}
							/>
						</div>
						<span>oder</span>
						<div className="grid gap-2">
							<input
								disabled={submitting}
								className="hidden"
								ref={fileInputRef}
								type="file"
								accept="text/plain"
								onChange={(event) => {
									const target = event.target as HTMLInputElement;
									const file = target.files?.[0];
									if (!file) {
										onError(new Error("Keine Datei wurde ausgewählt."));
										return;
									}

									file?.text()?.then((rawtext) => {
										const lines = rawtext.split(/\r?\n/);
										if (lines.length <= 0) {
											throw new Error("Datei hat keine Zeilen.");
										}
										const newpassword = lines[0].replace(/[^a-z0-9]/gi, '').trim();
										setPassword(newpassword);
										handleSubmit(newpassword);
									}).catch(onError);

									target.value = "";
								}}
							/>
							<Button
								disabled={submitting}
								type="button"
								onClick={(event) => {
									event.preventDefault();
									if (fileInputRef?.current) {
										fileInputRef.current.click();
									}
								}}
							>Aus Datei Laden</Button>

						</div>
					</div>
					<div className="flex gap-2">
						<Button variant="outline" type="button" onClick={() => { onCancel() }}>{justLoggedIn ? "Später" : "Abbrechen"}</Button>
						<Button className="ml-auto" type="submit" disabled={submitting}>
							{submitting ? <Loader2 className="mr-2 h-4 w-4 animate-spin inline" /> : null}
							<span>Schlüssel entsperren</span>
						</Button>
					</div>
					<p className="text-sm text-muted-foreground">
						Falls du dein Passwort verloren hast, kannst du in deinem Profil einen neuen Schlüssel erstellen. Dieser wird aber nicht auf alle Nachrichten zugriff haben.
					</p>
				</form>
			</DialogContent>
		</Dialog>
	)
}

